<?php
if(!defined('SYS_BASE_PATH')) exit('Direct links are forbidden');

class wforum_controllers_forum extends common_controller
{
protected $justadded = false;
protected $justdeleted = false;

function index($pars = '')
{
    if(!isset($this->request['forum'])) $this->redirect('wforum/index');;
    if(!$this->request['forum']) $this->redirect('wforum/index');;

    $_SESSION['current_forum'] = $this->request['forum'];
    $_SESSION['current_topic'] = 0;

    if(!$this->justadded and !$this->justdeleted)
    {
        $this->forum = $this->request['forum'];
        $this->errormessage = '';
    }
    if(!$this->justadded)
    {
        $this->topicname = (isset($this->request['topicname'])) ? $this->request['topicname'] : '';
        $this->description = (isset($this->request['description'])) ? $this->request['description'] : '';
        $this->notifytopcr = (isset($this->request['notifytopcr'])) ? $this->request['notifytopcr'] : 0;
        $this->sticky = (isset($this->request['sticky'])) ? $this->request['sticky'] : 0;
    }

    // Is private forum
    $this->userid = $this->parser->getUserId();
    $foruminfo = $this->getForuminfo();
    if(!$this->userid and $foruminfo[0]) $this->redirect('wforum/checkuser', 'loginhomeid='.$this->parser->pageId);
    $this->delete =  ($this->userid === $foruminfo[2]) || ($this->userid === $foruminfo[3]);

    $this->parser->utils->addjq();
    $model = new wforum_models_topics();
    //$model->extendedTinymce = true;
    $model->richedit_height = 200;
    $model->addTinymceScript();

    $pars = array();
    $pars['forum'] = $this->forum;
    $pars['pagelen'] = 20;
    $pars['showpaginator'] = true;
    $pars['page'] = (isset($this->request['page'])) ? $this->request['page'] : 0;

    $this->addform = $this->parser->checkPerms('wforum_rights_topics', 'c');
    if($this->addform)
    {
        $fields = array();
        $fields[] = array('topicname', $this->parser->gt('name'), "''");
        //$fields[] = array('description', $this->parser->gt('description'), "''");
        $this->parser->utils->formValidator('topicform', 'submitbutton', $fields);
    }


    $this->modeldata = $model->getTopics($pars);
    $this->paginator_info = $model->paginator_info;
    $this->paginator_html = '';
    if($this->paginator_info['totalpages'] > 1)
    {
        $ppars = array('page' => $this->paginator_info['page'],
                      'numrows' => $this->paginator_info['numrows'],
                      'pagelen' => $this->paginator_info['pagelen'],
                      'url' => $this->parser->pageId,
                      'args' => 'forum='.$this->forum,
                      'onclick' => ''
        );
        $this->paginator_html = $this->parser->utils->paginator($ppars);
    }

    // Set foto upload form
    $this->fotoform = '';
    $this->fotocnt = 0;
    if($this->userid)
    {
        include_once(SYS_BASE_PATH.'main/classes/wphoto.class.php');
        $foto = new wPhoto();
        //$foto->container = 'wgrid';
        $foto->objtype = 'wforum_posts';
        $foto->objid = 0;
        $foto->photoobjtype = 'wforum_posts_photo';

        $foto->adding = true;
        $foto->editing = true;
        $foto->deleting = true;

        $foto->addHidden('forum', $this->forum);
        $foto->addHidden('topicname', '');
        $foto->addHidden('description', '');

        $src = "
        <script type='text/javascript'>
        $(document).ready(function()
        {
            $('#uploader_submit_button').click(function() {
                try {
                    document.uploader_form.topicname.value = document.topicform.topicname.value;
                    document.uploader_form.description.value = $('#description').tinymce().getContent();
                } catch(e){}
                $('#uploader_form').submit();
            });
        });
        </script>
        ";
        $this->parser->addScript($src);


        $this->fotoform = $foto->show(false);
        $this->fotocnt = $this->parser->utils->getFieldFromSql("SELECT COUNT(*)
                            FROM wforum_posts_photo WHERE (masterid=0) AND (creatby='".$this->parser->getUserId()."')", 0);
    }

    if($this->parser->getUserId()) $this->metatitle = $this->parser->gt('forum').' | '.$this->parser->getUserName();
        else $this->metatitle = $this->parser->gt('forum');
    $this->addChild(array('wforum/breadcrumbs', 'forum='.$this->request['forum']));
    $this->addChild('wforum/searchform');
    $this->addChild('wforum/languages');
    $this->addChild('wforum/menu');
    $this->addChild('wforum/topmenu');
    $this->addChild('wforum/footer');
    $this->render();

}

public function getForuminfo()
{
    return $this->parser->utils->getFieldsFromSql("SELECT f.isprivate, f.nonregposts, f.creatby, f.moderator
                                                         FROM wforum_forums f
                                                         WHERE (f.id=".$this->parser->conn->escape($this->forum).")
                                                         ", array(0,0,0,0), 'num');
}

function addtopic()
{
    if(!isset($this->request['forum']))
    {
        $this->index();
        return;
    }
    $this->forum = $this->request['forum'];
    $this->topicname = (isset($this->request['topicname'])) ? $this->request['topicname'] : '';
    $this->notifytopcr = (isset($this->request['notifytopcr'])) ? $this->request['notifytopcr'] : 0;
    $this->sticky = (isset($this->request['sticky'])) ? $this->request['sticky'] : 0;
    $this->description = (isset($this->request['description'])) ? $this->request['description'] : '';

    if(!$this->parser->checkPerms('wforum_rights_topics', 'c'))
    {
        $this->index();
        return;
    }

    $model = new wforum_models_topics();
    $model->fields->forumid->val = $this->forum;
    $model->fields->name->val = $this->topicname;
    $model->fields->sticky->val = $this->sticky;
    $model->fields->notifytopcr->val = $this->notifytopcr;
    $this->errormessage = $model->insert();
    if(!$this->errormessage)
    {
        // Add post
        if(trim($this->description))
        {
            $post = new wforum_models_posts();
            $post->fields->forumid->val = $this->forum;
            $post->fields->topicid->val = $model->id;
            $post->fields->description->val = $this->description;
            $this->errormessage = $post->insert();
            if(!$this->errormessage) // Bind files and photos
            $this->parser->conn->Execute("UPDATE wforum_posts_photo SET masterid=".$post->id." WHERE (masterid=0) AND (creatby='".$this->parser->getUserId()."')");
        }
        $this->topicname = '';
        $this->notifytopcr = 0;
        $this->sticky = 0;
    }
    $this->justadded = true;
    $this->index();
}


public function deletetopic()
{
    if(!isset($this->request['forum']))
    {
        $this->index();
        return;
    }
    $topicid = (isset($this->request['topicid'])) ? $this->request['topicid'] : '';
    $this->forum = $this->request['forum'];
    $this->userid = $this->parser->getUserId();
    if(!$topicid || !$this->userid || !$this->forum)
    {
        $this->index();
        return;
    }

    $foruminfo = $this->getForuminfo();
    if(($this->userid !== $foruminfo[2]) and ($this->userid !== $foruminfo[3]))
    {
        $this->index();
        return;
    }
    $top = new wforum_models_topics();
    $top->id = $topicid;
    $this->errormessage = $top->delete();
    $this->justdeleted = true;
    $this->index();
}


}

?>