<?php
if(!defined('SYS_BASE_PATH')) exit('Direct links are forbidden');

class wforum_controllers_index extends common_controller
{
protected $justadded = false;
protected $justdeleted = false;


public function index($pars = '')
{
    $_SESSION['current_forum'] = 0;
    $_SESSION['current_topic'] = 0;

    $this->userid = $this->parser->getUserId();
    if(!$this->justadded and !$this->justdeleted)
    {
        $this->errormessage = '';
    }
    $this->categories = array();
    $this->moderators = array();
    if(!$this->justadded)
    {
        $this->forumname = (isset($this->request['forumname'])) ? $this->request['forumname'] : '';
        $this->description = (isset($this->request['description'])) ? $this->request['description'] : '';
        $this->sortorder = (isset($this->request['sortorder'])) ? $this->request['sortorder'] : 0;
        $this->category = (isset($this->request['category'])) ? $this->request['category'] : 0;
        $this->moderator = (isset($this->request['moderator'])) ? $this->request['moderator'] : $this->userid;
        $this->isprivate = (isset($this->request['isprivate'])) ? $this->request['isprivate'] : 0;
        $this->notifycr = (isset($this->request['notifycr'])) ? $this->request['notifycr'] : 0;
        $this->notifymod = (isset($this->request['notifymod'])) ? $this->request['notifymod'] : 0;
        $this->nonregposts = (isset($this->request['nonregposts'])) ? $this->request['nonregposts'] : 1;
    }


    $perms = $this->parser->checkPerms('wforum_rights_forums');
    $this->addform = $perms['c'];
    $this->delete = $perms['d'];
    if($this->addform)
    {
        $sql = 'SELECT objid, name_'.$this->parser->lang_suff.
        " FROM sys_objects WHERE objtype='wforum_cats' ORDER BY name_".$this->parser->lang_suff;
        $rs = $this->parser->conn->SelectLimit($sql, 100);
        $tmp = array();
        if($rs)
        while($row = $rs->FetchRow())
            $tmp[] = array('id' => $row[0], 'name' => $row[1], 'sel' => (''.$row[0] === ''.$this->category));
        $this->categories = $tmp;
        $sql = 'SELECT objid, name_'.$this->parser->lang_suff.
        " FROM sys_objects WHERE objtype='sys_users'
          AND ((objid IN(SELECT DISTINCT r.row_objid FROM sys_obj_array r
          WHERE  (r.row_objtype='sys_users')
          AND (r.col_objtype='sys_rights_roles')
          AND (r.col_objid IN('wforum_roles_moders')))) OR (objid='sys_superadmin')) ORDER BY name_".$this->parser->lang_suff;
        $rs = $this->parser->conn->SelectLimit($sql, 100);
        $tmp = array();
        if($rs)
        while($row = $rs->FetchRow())
            $tmp[] = array('id' => $row[0], 'name' => $row[1], 'sel' => (''.$row[0] === ''.$this->moderator));

        $this->moderators = $tmp;
        $fields = array();
        $fields[] = array('forumname', $this->parser->gt('name'), "''");
        //$fields[] = array('description', $this->parser->gt('description'), "''");
        $this->parser->utils->formValidator('topicform', 'submitbutton', $fields);

        $src = "<script type=\"text/javascript\">
            function showhidecateg(showhide)
            {
                if(showhide == 'show')
                {
                    document.getElementById('addcategpopupbox').style.visibility='visible';
                }else if(showhide == 'hide')
                {
                    document.getElementById('addcategpopupbox').style.visibility='hidden';
                }
            }
            function addcategory()
            {
                if(document.topicform.categname.value == '') return;
                document.topicform.action.value = 'addcategory';
                document.topicform.submit();
            }
        </script>";
        $this->parser->addScript($src);
    }


    $model = new wforum_models_index($this->parser);

    $this->modeldata = $model->getCategories();
    $this->lastposts = $model->getLastposts();

    $usr = $this->parser->getUserName();
    $this->loggeduser = $usr;

    if($this->parser->getUserId()) $this->metatitle = $this->parser->gt('forums').' | '.$usr;
        else $this->metatitle = $this->parser->gt('forums');
    $this->addChild('wforum/breadcrumbs');
    $this->addChild('wforum/searchform');
    $this->addChild('wforum/languages');
    $this->addChild('wforum/menu');
    $this->addChild('wforum/topmenu');
    $this->addChild('wforum/footer');
    $this->render();

}


public function addforum()
{
    if(!$this->parser->checkPerms('wforum_rights_forums', 'c'))
    {
        $this->index();
        return;
    }
    $this->forumname = (isset($this->request['forumname'])) ? $this->request['forumname'] : '';
    $this->description = (isset($this->request['description'])) ? $this->request['description'] : '';
    $this->sortorder = (isset($this->request['sortorder'])) ? $this->request['sortorder'] : 0;
    $this->category = (isset($this->request['category'])) ? $this->request['category'] : 0;
    $this->moderator = (isset($this->request['moderator'])) ? $this->request['moderator'] : $this->userid;
    $this->isprivate = (isset($this->request['isprivate'])) ? $this->request['isprivate'] : 0;
    $this->notifycr = (isset($this->request['notifycr'])) ? $this->request['notifycr'] : 0;
    $this->notifymod = (isset($this->request['notifymod'])) ? $this->request['notifymod'] : 0;
    $this->nonregposts = (isset($this->request['nonregposts'])) ? $this->request['nonregposts'] : 1;

    $model = new wforum_models_forums();
    $model->fields->name->val = $this->forumname;
    $model->fields->description->val = $this->description;
    $model->fields->sortorder->val = $this->sortorder;
    $model->fields->category->val = $this->category;
    $model->fields->moderator->val = $this->moderator;
    $model->fields->isprivate->val = $this->isprivate;
    $model->fields->notifycr->val = $this->notifycr;
    $model->fields->notifymod->val = $this->notifymod;
    $model->fields->nonregposts->val = $this->nonregposts;

    $this->errormessage = $model->insert();

    $this->justadded = true;
    $this->index();

}

public function deleteforum()
{
    if(!$this->parser->checkPerms('wforum_rights_forums', 'd'))
    {
        $this->index();
        return;
    }
    $forumid = (isset($this->request['forumid'])) ? $this->request['forumid'] : '';
    $this->userid = $this->parser->getUserId();
    if(!$forumid || !$this->userid)
    {
        $this->index();
        return;
    }
    $top = new wforum_models_forums();
    $top->id = $forumid;
    $this->errormessage = $top->delete();
    $this->justdeleted = true;
    $this->index();
}


public function addcategory()
{
    $this->forumname = (isset($this->request['forumname'])) ? $this->request['forumname'] : '';
    $this->description = (isset($this->request['description'])) ? $this->request['description'] : '';
    $this->sortorder = (isset($this->request['sortorder'])) ? $this->request['sortorder'] : 0;
    $this->category = (isset($this->request['category'])) ? $this->request['category'] : 0;
    $this->moderator = (isset($this->request['moderator'])) ? $this->request['moderator'] : $this->userid;
    $this->isprivate = (isset($this->request['isprivate'])) ? $this->request['isprivate'] : 0;
    $this->notifycr = (isset($this->request['notifycr'])) ? $this->request['notifycr'] : 0;
    $this->notifymod = (isset($this->request['notifymod'])) ? $this->request['notifymod'] : 0;
    $this->nonregposts = (isset($this->request['nonregposts'])) ? $this->request['nonregposts'] : 1;

    $categname = (isset($this->request['categname'])) ? trim($this->request['categname']) : '';
    if(!$this->parser->checkPerms('wforum_rights_forums', 'c') || !$categname)
    {
        $this->index();
        return;
    }

    include_once(SYS_BASE_PATH.'main/objects/objects.class.php');
    $model = new wObjects('wforum_cats');
    $model->fields->name->val = $categname;

    $this->errormessage = $model->insert();
    if(!$this->errormessage) $this->category = $model->id;
    $this->justadded = true;
    $this->index();
}

}

?>