<?php
if(!defined('SYS_BASE_PATH')) exit('Direct links are forbidden');

class wforum_controllers_topic extends common_controller
{
protected $justadded = false;
protected $justdeleted = false;

public function index($pars = '')
{
    if(!isset($this->request['topic'])) $this->redirect('wforum/index');
    $gotopost = (isset($this->request['gotopost'])) ? $this->request['gotopost'] : 0;
    if(!$this->request['topic']) $this->redirect('wforum/index');

    if(!$this->justadded and !$this->justdeleted)
    {
        $this->topic = $this->request['topic'];
        $this->errormessage = '';
    }
    if(!$this->justadded)
    {
        $this->username = (isset($this->request['username'])) ? $this->request['username'] : '';
        $this->description = (isset($this->request['description'])) ? $this->request['description'] : '';
    }

    // Is private forum
    $this->userid = $this->parser->getUserId();
    $foruminfo = $this->getForuminfo();
    if(!$this->userid and $foruminfo[0]) $this->redirect('wforum/checkuser', 'loginhomeid='.$this->parser->pageId);

    $_SESSION['current_forum'] = $foruminfo[2];
    $_SESSION['current_topic'] = $this->request['topic'];

    $this->delete =  ($this->userid === $foruminfo[3]) || ($this->userid === $foruminfo[4]);
    $this->addform =  $foruminfo[1] || $this->userid;
    if($this->addform)
    {
        $fields = array();
        $fields[] = array('username', $this->parser->gt('firstname'), "''");
        if(!$this->userid) $fields[] = array('captchastring', $this->parser->gt('entercaptcham'), "''");
        $this->parser->utils->formValidator('postform', 'submitbutton', $fields);
    }
    if(!$this->justadded) $this->username = ($this->userid) ? $this->parser->utils->getFieldFromSql("SELECT name_".$this->parser->lang_suff."
                                                                         FROM sys_objects
                                                                         WHERE objid='".$this->userid."'", '') : '';

    // Count views of a topic
    if(!isset($_SESSION['wforumviewtopics'])) $_SESSION['wforumviewtopics'] = array();
    if(!in_array($this->request['topic'], $_SESSION['wforumviewtopics']))
    {
        $_SESSION['wforumviewtopics'][] = $this->request['topic'];
        $this->parser->conn->Execute("UPDATE wforum_topics SET views=views+1
                                     WHERE id=".$this->parser->conn->escape($this->topic));
    }

    $this->parser->utils->addjq();
    $model = new wforum_models_posts();
    $model->richedit_height = 200;
    $model->addTinymceScript();
    $model->addFancyScript();
    $src = "
    <script type='text/javascript'>
function getquote(usr)
{
    var text = '';
    if(window.getSelection)
    {
        text = window.getSelection().toString();
    } else if (document.selection && document.selection.type != 'Control')
    {
        text = document.selection.createRange().text;
    }
    if(text == '') return;
    $('#description').tinymce().execCommand('mceInsertContent',false, \"<div class='quote'><b>\" + usr +\"</b><div>\" + text + \"</div></div><p> </p>\");
}


    </script>
    ";
    $this->parser->addScript($src);


    $pars = array();
    $pars['topic'] = $this->request['topic'];
    $pars['pagelen'] = 20;
    $pars['showpaginator'] = true;
    $pars['page'] = (isset($this->request['page'])) ? $this->request['page'] : 0;

    if($gotopost)
    {
        // calculate page for this post
        // number of records with this post
        $cnt = $this->parser->utils->getFieldFromSql("SELECT COUNT(*)
                                                      FROM wforum_posts
                                                      WHERE (topicid=".$this->parser->conn->escape($this->topic).")
                                                      AND (id>0)
                                                      AND (id<=".$gotopost.")", 0);
        $pars['page'] = ceil($cnt / $pars['pagelen']) - 1;
        if($pars['page'] < 0) $pars['page'] = 0;
    }

    $this->modeldata = $model->getPosts($pars);
    $this->paginator_info = $model->paginator_info;
    $this->paginator_html = '';
    if($this->paginator_info['totalpages'] > 1)
    {
        $ppars = array('page' => $this->paginator_info['page'],
                      'numrows' => $this->paginator_info['numrows'],
                      'pagelen' => $this->paginator_info['pagelen'],
                      'url' => $this->parser->pageId,
                      'args' => 'topic='.$this->topic,
                      'onclick' => ''
        );
        $this->paginator_html = $this->parser->utils->paginator($ppars);
    }

    if($this->parser->getUserId()) $this->metatitle = $this->parser->gt('topic').' | '.$this->parser->getUserName();
        else $this->metatitle = $this->parser->gt('topic');
    $this->addChild(array('wforum/breadcrumbs', 'topic='.$this->request['topic']));
    $this->addChild('wforum/searchform');
    $this->addChild('wforum/languages');
    $this->addChild('wforum/menu');
    $this->addChild('wforum/topmenu');
    $this->addChild('wforum/footer');
    $this->render();

}

public function getForuminfo()
{
    return $this->parser->utils->getFieldsFromSql("SELECT f.isprivate, f.nonregposts, t.forumid, f.creatby, f.moderator
                                                         FROM wforum_forums f, wforum_topics t
                                                         WHERE (t.id=".$this->parser->conn->escape($this->topic).")
                                                         AND (t.forumid=f.id)", array(0,0,0,0,0), 'num');
}

public function addpost()
{
    if(!isset($this->request['topic']))
    {
        $this->index();
        return;
    }
    $this->topic = $this->request['topic'];
    if(!$this->request['topic'])
    {
        $this->index();
        return;
    }

    $this->username = (isset($this->request['username'])) ? $this->request['username'] : '';
    $this->description = (isset($this->request['description'])) ? $this->request['description'] : '';
    $captchastring = (isset($this->request['captchastring'])) ? $this->request['captchastring'] : '';

    $this->userid = $this->parser->getUserId();
    $foruminfo = $this->getForuminfo();
    if(!$this->userid and $foruminfo[0]) $this->redirect('wforum/checkuser', 'loginhomeid='.$this->parser->pageId);

    if(isset($_SESSION['captcha']) and !$this->parser->getUserId())
    {
        if(($_SESSION['captcha'] !== $captchastring) or !$captchastring)
        {
            $this->errormessage = $this->parser->gt('wrongcaptcha');
            $this->justadded = true;
            $this->index();
            return;
        }
    }

    // Add post
    if(trim($this->description))
    {
        $post = new wforum_models_posts();
        $post->fields->forumid->val = $foruminfo[2];
        $post->fields->topicid->val = $this->topic;
        $post->fields->username->val = $this->username;
        $post->fields->description->val = $this->description;
        $this->errormessage = $post->insert();
        $_SESSION['captcha'] = '';
        if(!$this->errormessage)
        {
            $this->request['gotopost'] = $post->id;
            $this->description = '';
        }
    } else $this->errormessage = $this->parser->gt('valuereq').': '.$this->parser->gt('post');
    $this->justadded = true;
    $this->index();
}


public function deletepost()
{
    if(!isset($this->request['topic']))
    {
        $this->index();
        return;
    }
    $this->topic = $this->request['topic'];
    if(!$this->request['topic'])
    {
        $this->index();
        return;
    }
    $this->userid = $this->parser->getUserId();
    $postid = (isset($this->request['postid'])) ? $this->request['postid'] : '';
    if(!$postid || !$this->userid)
    {
        $this->index();
        return;
    }
    $foruminfo = $this->getForuminfo();
    if(!$this->userid and $foruminfo[0]) $this->redirect('wforum/checkuser', 'loginhomeid='.$this->parser->pageId);

    if(($this->userid !== $foruminfo[3]) and ($this->userid !== $foruminfo[4]))
    {
        $this->index();
        return;
    }
    $post = new wforum_models_posts();
    $post->id = $postid;
    $this->errormessage = $post->delete();
    $this->justdeleted = true;
    $this->index();
}

}

?>