<?php
class wforum_models_index
{

protected $parser;
public $forumpage = 'wforum/forum';
public $topicpage = 'wforum/topic';

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getData()
{
    //$output = 'Data from model index';
    $output = $this->parser->parsePageContent();
    return $output;
}

public function getCategories($pars = array())
{
    $res = array();
    $pagelen = (isset($pars['pagelen'])) ? $pars['pagelen']  : 20;
    $page = (isset($pars['page'])) ? $pars['page']  : 0;
    $getforums = (isset($pars['getforums'])) ? $pars['getforums']  : true;
    $q = $this->parser->utils->sql();

    $q->select('o.objid');
    $q->lselect('o.name');
    $q->select('o.avatar');
    $q->select('o.flt1');
    $q->from('sys_objects o');
    $q->where("o.objid<>'0'");
    $q->where("o.objtype='wforum_cats'");
    if(!$this->parser->getUserId()) $q->where('o.isprivate=0');
    $q->orderby('o.flt1');
    $q->lorderby('o.name');
    $rs = $this->parser->conn->SelectLimit($q->getSql(), $pagelen, $page);
    if($rs->NumRows() <= 0) return $res;
    while($row = $rs->FetchRow())
    {
        $forums = array();
        if($getforums)
        {
            $ppars = array();
            $ppars['category'] = $row[0];
            $forums = $this->getForums($ppars);
        }
        $res[] = array('id' => $row[0],
                       'name' => $row[1],
                       'avatar' => (($row[2]) ? SYS_BASE_URL.$row[2] : ''),
                       'forums' => $forums
        );
    }
    return $res;
}

public function getForums($pars = array())
{
    $res = array();
    $pagelen = (isset($pars['pagelen'])) ? $pars['pagelen']  : 100;
    $page = (isset($pars['page'])) ? $pars['page']  : 0;
    $category = (isset($pars['category'])) ? $pars['category']  : 0;
    $q = $this->parser->utils->sql();

    $q->select('o.id');
    $q->select('o.name');
    $q->select('o.avatar');
    $q->select('o.sortorder');
    $q->select('o.topics');
    $q->select('o.posts');
    $q->select('o.description');
    $q->from('wforum_forums o');
    $q->where('o.id>0');
    if($category) $q->where("o.category='".$category."'");
    if(!$this->parser->getUserId()) $q->where('o.isprivate=0');
    $q->orderby('o.sortorder');
    $q->orderby('o.name');

    $rs = $this->parser->conn->SelectLimit($q->getSql(), $pagelen, $page);
    if($rs->NumRows() <= 0) return $res;
    while($row = $rs->FetchRow())
    {
        $href = $this->parser->makeUrl($this->forumpage, 'forum='.$row[0]);
        $res[] = array('id' => $row[0],
                       'name' => $row[1],
                       'avatar' => (($row[2]) ? SYS_BASE_URL.$row[2] : ''),
                       'topics' => $row[4],
                       'posts' => $row[5],
                       'description' => $row[6],
                       'href' => $href
        );
    }
    return $res;

}


public function getLastposts()
{
    $res = array();

    $extr = '';
    if(!$this->parser->getUserId()) $extr .= "AND (f.isprivate=0) ";

    $sql = "SELECT t.id AS tid, t.name AS tname, p.id AS poastid, p.description AS postcontent,
    p.creaton AS pcreaton, p.username AS pusername,
    f.id AS fid, f.name AS fname
    FROM wforum_topics t, wforum_posts p, wforum_forums f
    WHERE (p.id>0)
    AND (p.topicid=t.id)
    ".$extr."
    AND (t.forumid=f.id)
    ORDER BY tid DESC, poastid DESC";

    $rs = $this->parser->conn->SelectLimit($sql, 10, 0);
    if($rs->NumRows() <= 0) return $res;
    while($row = $rs->FetchRow())
    {
        $href = $this->parser->makeUrl($this->topicpage, 'topic='.$row[0].'&gotopost='.$row[2].'#post'.$row[2]);
        $res[] = array('topicid' => $row[0],
                       'topicname' => $row[1],
                       'postid' => $row[2],
                       'post' => mb_substr(strip_tags($row[3]), 0, 255, $this->parser->config['charset']),
                       'creaton' => $this->parser->utils->isoToDateformat($row[4], true),
                       'username' => $row[5],
                       'forumid' => $row[6],
                       'forumname' => $row[7],
                       'href' => $href
        );
    }
    return $res;

}

}

?>