<?php
class wforum_models_messages
{
protected $parser;

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getList()
{
    $parser = $this->parser;

    // Check Rights
    if(!$this->parser->getUserId()) $this->parser->redirect('wforum/checkuser', 'loginhomeid='.$this->parser->pageId);
    $perm = $parser->checkPerms('0');
    if(!$perm['r']) return $parser->gt('not_perms');
    $perm['d'] = $parser->isSuperAdmin();
    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
    $w = new wAjaxGrid();
    $filter_wasread = (isset($_REQUEST['filter_wasread'])) ? $_REQUEST['filter_wasread'] : '';
    $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 0;
    include_once(SYS_BASE_PATH.'main/classes/intmail.class.php');
    $w->f = new wintmail();
    $w->edit_table_alias = 'o';
    //$w->caption = $parser->gt('sys_refs_sys_intmail', __FILE__);
    $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='sys_intmail'", '').' - '.$parser->getUserName();

    $w->q->select('o.id',  $parser->gt('id'));
    $w->q->select('o.createdon', $parser->gt('createdon'));
    $w->q->from('sys_intmail o');
    $w->q->from('sys_objects p');
    $w->q->where("o.id<>'0'");
    $w->q->orderby('o.createdon DESC');

    if($filter_period)
    {
         $per = $parser->utils->getPeriod($filter_period, true);
         $w->q->where("o.createdon ".$per);
         $w->f->extra_deleteAll_sql .= "AND (createdon ".$per.")";
    }
    switch($filter_wasread)
    {
        case 0: $w->q->where("o.wasread=0");
                $w->q->where("o.touserid='".$parser->getUserId()."'");
                $w->f->extra_deleteAll_sql .= "AND wasread=0 AND touserid='".$parser->getUserId()."'";
                $w->q->where("o.fromuserid=p.objid");
                $w->editing = $perm['u'];
                $w->adding = $perm['c'];
                $w->deleting = $perm['d'];
                $w->multiselect = $perm['d'];
                $w->q->select('p.name', $parser->gt('from'), array('lang' =>true));
        break;
        case 1: $w->q->where("o.wasread=1");
                $w->q->where("o.touserid='".$parser->getUserId()."'");
                $w->f->extra_deleteAll_sql .= "AND wasread=1 AND touserid='".$parser->getUserId()."'";
                $w->q->where("o.fromuserid=p.objid");
                $w->deleting = $perm['d'];
                $w->multiselect = $perm['d'];
                $w->q->select('p.name', $parser->gt('from'), array('lang' =>true));
        break;
        case 2: $w->q->where("o.wasread=0");
                $w->q->where("o.fromuserid='".$parser->getUserId()."'");
                $w->q->where("o.touserid=p.objid");
                $w->f->extra_deleteAll_sql .= "AND wasread=0 AND fromuserid='".$parser->getUserId()."'";
                $w->editing = $perm['u'];
                $w->adding = $perm['c'];
                $w->copying = $perm['c'];
                $w->deleting = $perm['d'];
                $w->multiselect = $perm['d'];
                $w->q->select('p.name', $parser->gt('to'), array('lang' =>true));
        break;
        case 3: $w->q->where("o.wasread=1");
                $w->q->where("o.touserid=p.objid");
                $w->q->where("o.fromuserid='".$parser->getUserId()."'");
                $w->f->extra_deleteAll_sql .= "AND wasread=1 AND fromuserid='".$parser->getUserId()."'";
                $w->q->select('p.name', $parser->gt('to'), array('lang' =>true));
        break;
    }
    $w->q->select('o.message',  $parser->gt('message'), array('html' => 1));

    $w->multiselect = false;
    $w->en_mainmenu = false;


    $pars = array();
    $pars['onchange'] = $w->container."_postAction('',0)";
    $pars['name'] = 'filter_period';
    $pars['val'] = $filter_period;
    $w->addCell($parser->utils->periodMenu($pars));

    $pars = array();
    $pars['onchange'] = $w->container."_postAction('',0)";
    $pars['name'] = 'filter_wasread';
    $pars['val'] = $filter_wasread;
    $pars['options'] = array($parser->gt('mailincomes'), $parser->gt('mailread'), $parser->gt('mailoutgoing'), $parser->gt('mailposted'));
    $w->addCell($parser->utils->dropdownMenu($pars));

    $w->addSearchField('o.message', $parser->gt('message'), 'C');
    $w->addSearchField('o.fromuserid', $parser->gt('from'), 'sys_users');
    $w->addSearchField('o.touserid', $parser->gt('to'), 'sys_users');
    $w->cardurl = $parser->makeUrl('sys_intmail');

    ob_start();
    $w->show();
    $output = ob_get_contents();
    ob_end_clean();

    return $output;

}

}

?>
