<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wforum_models_posts extends wPrototype
{
protected $parser;
public $paginator_info = array();

public function __construct($objtype = '', $id = '')
{
    global $parser;
    $this->parser = $parser;
    $this->id = $id;
    parent::__construct('wforum_posts');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
    $this->showformTinymceScript = true;
    $this->richedit_height = 300;
}


protected function _onBeforeInsert()
{
    global $parser;
    $this->setFieldNewVal('creatby', $parser->getUserId());
    $this->setFieldNewVal('creaton', $parser->utils->toDate('', true));
    $this->setFieldNewVal('ip', $_SERVER['REMOTE_ADDR']);

    if(!trim($this->getFieldNewVal('username')))
    {
        if($this->getFieldNewVal('creatby'))
            $this->setFieldNewVal('username', $parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff."
                                                                  FROM sys_objects
                                                                  WHERE (objid='".$this->getFieldNewVal('creatby')."')
                                                                  ", ''));
                else $this->setFieldNewVal('username', $parser->gt('guest'));
    }
    return '';
}

protected function _onInsert()
{
    $this->calcTopic();
    $this->calcForum();

    $justsent = '';
    $justsentm = '';
    $usr = $this->parser->getUserId();
    $a = $this->parser->utils->getFieldsFromSql("SELECT f.notifycr, f.notifymod, f.creatby, f.moderator,
                                                 c.str1_".$this->parser->lang_suff." AS cemail,
                                                 m.str1_".$this->parser->lang_suff." AS memail,
                                                 f.name AS fname
                                                 FROM wforum_forums f, sys_objects c, sys_objects m
                                                 WHERE (f.id=".$this->getFieldNewVal('forumid').")
                                                 AND (f.creatby=c.objid)
                                                 AND (f.moderator=m.objid)
                                                 ", array(0,0,0,0,'','',''), 'num');

    $postref = "<a href=\"".$this->parser->makeUrl('wforum/topic', 'topic='.$this->getFieldNewVal('topicid').'&gotopost='.$this->id.'#post'.$this->id, false,true)."\">".
        mb_substr(strip_tags($this->getFieldNewVal('description')), 0, 300, $this->parser->config['charset'])."</a>";

    if($a[0] and trim($a[4]) and ($usr !== $a[2]))
    {
        // Notify creator
        $pars = array('to' => $a[4],
                      'subject' => strip_tags($this->parser->gt('subjnewpost', '', $a[6])),
                      'message' => $this->parser->gt('messnewpost', '', $postref, $a[6])
                              );
        $this->parser->utils->sendMail($pars);
        $justsent = $a[2];
    }
    if($a[1] and trim($a[5]) and ($justsent !== $a[3]) and ($usr !== $a[3]))
    {
        // Notify creator
        $pars = array('to' => $a[5],
                      'subject' => strip_tags($this->parser->gt('subjnewpost', '', $a[6])),
                      'message' => $this->parser->gt('messnewpost', '', $postref, $a[6])
                              );
        $this->parser->utils->sendMail($pars);
        $justsentm = $a[3];
    }

    // Notify creator of topic
    $a = $this->parser->utils->getFieldsFromSql("SELECT t.notifytopcr, t.creatby,
                                                 c.str1_".$this->parser->lang_suff." AS cemail,
                                                 t.name AS tname
                                                 FROM wforum_topics t, sys_objects c
                                                 WHERE (t.id=".$this->getFieldNewVal('topicid').")
                                                 AND (t.creatby=c.objid)
                                                 ", array(0,0,'',''), 'num');
    if($a[0] and trim($a[2]) and ($justsent !== $a[1]) and ($justsentm !== $a[1]) and ($usr !== $a[1]))
    {
        // Notify creator
        $pars = array('to' => $a[5],
                      'subject' => strip_tags($this->parser->gt('subjnewposttop', '', $a[3])),
                      'message' => $this->parser->gt('messnewposttop', '', $postref, $a[3])
                              );
        $this->parser->utils->sendMail($pars);
        $justsentm = $a[3];
    }

    return '';
}

protected function _onBeforeDelete()
{
    // Delete all photos and files
    $sql =   "SELECT o.id
              FROM wforum_posts_photo o
              WHERE (o.masterid=".$this->id.")";
    $rs = $this->parser->conn->SelectLimit($sql, 1000);
    while($row = $rs->FetchRow())
    {
        $ext = (trim($row[4])) ? $row[4] : 'jpg';
        $icon = SYS_BASE_PATH."userdata/modules/wforum/wforum_posts_photo/icons/".$row[0].".".$ext;
        $imgbig = SYS_BASE_PATH."userdata/modules/wforum/wforum_posts_photo/".$row[0].".".$ext;
        if(file_exists($icon)) @unlink($icon);
        if(file_exists($imgbig)) @unlink($imgbig);
        $this->parser->conn->Execute("DELETE FROM wforum_posts_photo WHERE id=".$row[0]);
    }
    return '';
}

protected function _onDelete()
{
    $this->calcTopic();
    $this->calcForum();
    return '';
}

protected function calcForum($upd = true)
{
    global $parser;
    $qty = $parser->utils->getFieldFromSql('SELECT COUNT(*) FROM wforum_posts WHERE forumid='.$this->getFieldVal('forumid'), 0);
    if($upd) $parser->conn->Execute('UPDATE wforum_forums SET posts='.$qty.' WHERE id='.$this->getFieldVal('forumid'));
    return $qty;
}
protected function calcTopic($upd = true)
{
    global $parser;
    $qty = $parser->utils->getFieldFromSql('SELECT COUNT(*) FROM wforum_posts WHERE topicid='.$this->getFieldVal('topicid'), 0);
    if($upd) $parser->conn->Execute('UPDATE wforum_topics SET posts='.$qty.", lastpostid=".$this->id.", lastposttime=".
                                     $parser->utils->getCurrDay().", lastposter='".$parser->conn->escape($this->getFieldVal('username'))."'
                                     WHERE id=".$this->getFieldVal('topicid'));
    return $qty;
}


function getPosts($pars = array())
{
    // Downloader
    if(isset($_GET['download_fileid']))
    {
        if($this->parser->robot) return '';
        if(trim($_GET['download_fileid']))
        {
            $filename = SYS_BASE_PATH."userdata/modules/wforum/wforum_posts_photo/".$_GET['download_fileid'].'.zip';
            if(($fp = @fopen($filename, "r")))
            {
                // Incr counter
                $orig_name = $this->parser->utils->getFieldFromSql("SELECT notes
                                                                  FROM wforum_posts_photo
                                                                  WHERE (id=".$this->parser->conn->escape($_GET['download_fileid']).")
                                                                  ", '');
                if(!$orig_name) $orig_name = $_GET['download_fileid'];
                    else $orig_name = $this->parser->utils->ruTranslit($orig_name);
                $this->parser->conn->Execute("UPDATE wforum_posts_photo SET views=views+1 WHERE id=".$this->parser->conn->escape($_GET['download_fileid']));
                $filetype = 'application/x-zip-compressed';

                while(@ob_end_clean());
                $file_size = filesize($filename);
                header("Content-Disposition: attachment; filename=".$orig_name);
                header("Content-Type: ".$filetype."; name=\"".$_GET['download_fileid']."\"");
                header("Content-Transfer-Encoding: binary");
                header("Content-Length: $file_size");
                $_GET['download_fileid'] = '';
                while($file_size)
                {
                    $buff = ($file_size > 262144) ? 262144 : $file_size;
                    print(fread($fp, $buff));
                    $file_size -= $buff;
                }
                fclose($fp);
                exit;
            }
        }
    }

    $res = array();
    $pagelen = (isset($pars['pagelen'])) ? $pars['pagelen']  : 20;
    $page = (isset($pars['page'])) ? $pars['page']  : 0;
    $topic = (isset($pars['topic'])) ? $pars['topic']  : 0;
    $showpaginator = (isset($pars['showpaginator'])) ? $pars['showpaginator']  : true;
    if(!$topic) return $res;

    $q = $this->parser->utils->sql();

    $q->select('o.id');
    $q->select('o.username');
    $q->select('o.creatby');
    $q->select('o.creaton');
    $q->select('o.description');
    $q->select('u.avatar');
    $q->select('o.topicid');
    $q->select('o.forumid');
    $q->from('wforum_posts o');
    $q->from('sys_objects u');
    $q->where('o.id>0');
    $q->where('o.creatby=u.objid');
    if($topic) $q->where("o.topicid=".$topic);

    if(!$this->parser->getUserId())
    {
        $q->from('wforum_forums f');
        $q->where('o.forumid=f.id');
        $q->where('f.isprivate=0');
    }
    $q->orderby('o.id');

    $sql = $q->getSql();
    $totalpages = 0;
    $this->paginator_info = array('page' => 0,
                  'numrows' => 0,
                  'pagelen' => $pagelen,
                  'totalpages' => 0
    );
    if($showpaginator)
    {
        $pg = $q->parseSql($sql, true);
        $totalpages = ceil ($pg['rows'] / $pagelen);
        $numrows = $pg['rows'];
        if($page >= $totalpages) $page = $totalpages - 1;
        if($page < 0) $page = 0;
        $this->paginator_info = array('page' => $page,
                      'numrows' => $numrows,
                      'pagelen' => $pagelen,
                      'totalpages' => $totalpages
        );
    }

    $rs = $this->parser->conn->SelectLimit($sql, $pagelen, $page * $pagelen);
    if($rs->NumRows() <= 0) return $res;
    $cnt = 0;
    while($row = $rs->FetchRow())
    {
        $avatar = ($row[5]) ? SYS_BASE_URL.$row[5] : SYS_BASE_URL.'main/images/icons/avatar.png';
        $description = str_replace("../", "", $row[4]);
        $description = str_replace("libs/js/tiny_mce", SYS_BASE_URL."libs/js/tiny_mce", $description);

        $res[] = array('id' => $row[0],
                       'cnt' => $cnt++,
                       'username' => $row[1],
                       'avatar' => $avatar,
                       'creatby' => $row[2],
                       'topicid' => $row[6],
                       'forumid' => $row[7],
                       'creaton' => $this->parser->utils->isoToDateformat($row[3], true),
                       'description' => $description,
                       'photos' => $this->getPhotos($row[0])
        );
    }
    return $res;

}

public function addFancyScript($id = 'gallery')
{
    $this->parser->addCSS(SYS_BASE_URL."libs/js/fancybox/jquery.fancybox.css");
    $this->parser->addScript(SYS_BASE_URL."libs/js/fancybox/jquery.mousewheel.js");
    $this->parser->addScript(SYS_BASE_URL."libs/js/fancybox/jquery.fancybox.js");
    $src = "<script type=\"text/javascript\">
    $(document).ready(function()
    {
        $(\"a.".$id."\").fancybox(
        {
            \"padding\" : 20,
            \"imageScale\" : false,
            \"zoomOpacity\" : false,
            \"zoomSpeedIn\" : 500,
            \"zoomSpeedOut\" : 500,
            \"zoomSpeedChange\" : 500,
            //\"frameWidth\" : 700,
            //\"frameHeight\" : 600,
            \"overlayShow\" : true,
            \"overlayOpacity\" : 0.8,
            \"hideOnContentClick\" :false,
            \"centerOnScroll\" : false
        });
        $(\"a.".$id."_youtube\").fancybox(
        {
            'padding'       : 0,
            'autoScale'     : false,
            'transitionIn'  : 'none',
            'transitionOut' : 'none',
            'title'         : this.title,
            'width'         : 700,
            'height'        : 600,
            'type'          : 'swf',
            'swf'           : {
            'wmode'             : 'transparent',
            'allowfullscreen'   : 'true'
            }
        });

    });
    </script>";
    $this->parser->addScript($src);
}

public function getPhotos($id = 0)
{
    $res = array();
    if(!$id) $id = $this->id;
    if(!$id) return array();
    $sql =   "SELECT o.id, o.sortorder, o.notes, o.clipurl, o.filetype, o.views
              FROM wforum_posts_photo o
              WHERE (o.masterid=".$id.")
              ORDER BY o.sortorder, o.id";
    $rs = $this->parser->conn->SelectLimit($sql, 100);
    while($row = $rs->FetchRow())
    {
        $ext = (trim($row[4])) ? $row[4] : 'jpg';
        $icon = SYS_BASE_URL."userdata/modules/wforum/wforum_posts_photo/icons/".$row[0].".".$ext;
        $imgbig = SYS_BASE_URL."userdata/modules/wforum/wforum_posts_photo/".$row[0].".".$ext;
        $filename = SYS_BASE_PATH."userdata/modules/wforum/wforum_posts_photo/".$row[0].".".$ext;
        $file_size = @filesize($filename);
        if($file_size) $file_size = $this->parser->utils->nf($file_size / 1048576, 3);

        if($ext == 'swf')
        {
            $icon = SYS_BASE_URL.'main/images/icons/video.png';
        }
        elseif($ext == 'zip')
        {
            $icon = $imgbig = SYS_BASE_URL.'main/images/icons/archive.png';
        }
        $res[] =  array('id' => $row[0],
                        'notes' => $row[2],
                        'url' => $row[3],
                        'icon' => $icon,
                        'imgbig' => $imgbig,
                        'downloads' => $row[5],
                        'size' => $file_size,
                        'ext' => $row[4]);
    }
    return $res;
}

}

?>