<?php
class wforum_models_search
{
protected $parser;
public $paginator_info = array();
public $topipcage = 'wforum/topic';

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getList($pars = array())
{
    $res = array();

    $pagelen = (isset($pars['pagelen'])) ? $pars['pagelen']  : 20;
    $page = (isset($pars['page'])) ? $pars['page']  : 0;
    $query = (isset($pars['query'])) ? $pars['query']  : 0;
    $showpaginator = (isset($pars['showpaginator'])) ? $pars['showpaginator']  : true;
    if(!trim($query)) return $res;

    $current_forum = (isset($_SESSION['current_forum'])) ? $_SESSION['current_forum'] : '';
    $current_topic = (isset($_SESSION['current_topic'])) ? $_SESSION['current_topic'] : '';

    $extr = '';
    if($current_forum) $extr .= "AND (f.id=".$current_forum.") ";
    if($current_topic) $extr .= "AND (t.id=".$current_topic.") ";
    if(!$this->parser->getUserId()) $extr .= "AND (f.isprivate=0) ";

    $qstr1 = '';
    $qstr2 = '';
    $ar = explode(' ', trim($query));
    for($i = 0; $i < sizeof($ar); $i++)
    {
        if(!trim($ar[$i]))    continue;
        if($qstr1) $qstr1 .= ' AND ';
        if($qstr1) $qstr2 .= ' AND ';
        $qstr1 .= " (t.name LIKE '%".$ar[$i]."%')";
        $qstr2 .= " (p.description LIKE '%".$ar[$i]."%')";
    }
    $sql = "SELECT t.id AS tid, t.name AS tname, 0 AS poastid, '' AS postcontent,
    '' AS pcreaton, '' AS pusername,
    f.id AS fid, f.name AS fname
    FROM wforum_topics t, wforum_forums f
    WHERE (".$qstr1.")
    AND (t.id>0)
    ".$extr."
    AND (t.forumid=f.id)
    UNION ALL
    SELECT t.id AS tid, t.name AS tname, p.id AS poastid, p.description AS postcontent,
    p.creaton AS pcreaton, p.username AS pusername,
    f.id AS fid, f.name AS fname
    FROM wforum_topics t, wforum_posts p, wforum_forums f
    WHERE (".$qstr2.")
    AND (p.id>0)
    AND (p.topicid=t.id)
    ".$extr."
    AND (t.forumid=f.id)
    ORDER BY tid DESC, poastid DESC";

    $totalpages = 0;
    $this->paginator_info = array('page' => 0,
                  'numrows' => 0,
                  'pagelen' => $pagelen,
                  'totalpages' => 0
    );
    if($showpaginator)
    {
        $rs = @$this->parser->conn->Execute($sql);
        $numrows = ($rs) ? $rs->NumRows() : 0;
        $totalpages = ceil ($numrows / $pagelen);
        if($page >= $totalpages) $page = $totalpages - 1;
        if($page < 0) $page = 0;
        $this->paginator_info = array('page' => $page,
                      'numrows' => $numrows,
                      'pagelen' => $pagelen,
                      'totalpages' => $totalpages
        );
    }

    $rs = $this->parser->conn->SelectLimit($sql, $pagelen, $page * $pagelen);
    if($rs->NumRows() <= 0) return $res;
    while($row = $rs->FetchRow())
    {
        $href = ($row[2]) ? $this->parser->makeUrl($this->topipcage, 'topic='.$row[0].'&gotopost='.$row[2].'#post'.$row[2]) : $this->parser->makeUrl($this->topipcage, 'topic='.$row[0]);
        $res[] = array('topicid' => $row[0],
                       'topicname' => $row[1],
                       'postid' => $row[2],
                       'post' => mb_substr(strip_tags($row[3]), 0, 50, $this->parser->config['charset']),
                       'creaton' => $this->parser->utils->isoToDateformat($row[4], true),
                       'username' => $row[5],
                       'forumid' => $row[6],
                       'forumname' => $row[7],
                       'href' => $href
        );
    }
    return $res;
}

}
?>
