<?php

include_once(SYS_BASE_PATH.'main/classes/wprototype.class.php');
class wforum_models_topics extends wPrototype
{
protected $parser;
public $paginator_info = array();
public $topicpage = 'wforum/topic';

public function __construct($objtype = '', $id = '')
{
    global $parser;
    $this->parser = $parser;
    $this->id = $id;
    parent::__construct('wforum_topics');
    $this->extra_deleteAll_sql = "WHERE id<>'0' ";
    $this->translateLabels();
}


protected function _onBeforeInsert()
{
    global $parser;
    $this->setFieldNewVal('creatby', $parser->getUserId());
    $this->setFieldNewVal('creaton', $parser->utils->toDate('', true));
    return '';
}

protected function _onInsert()
{
    $this->calc();
    $justsent = '';
    $usr = $this->parser->getUserId();
    $a = $this->parser->utils->getFieldsFromSql("SELECT f.notifycr, f.notifymod, f.creatby, f.moderator,
                                                 c.str1_".$this->parser->lang_suff." AS cemail,
                                                 m.str1_".$this->parser->lang_suff." AS memail,
                                                 f.name AS fname
                                                 FROM wforum_forums f, sys_objects c, sys_objects m
                                                 WHERE (f.id=".$this->getFieldNewVal('forumid').")
                                                 AND (f.creatby=c.objid)
                                                 AND (f.moderator=m.objid)
                                                 ", array(0,0,0,0,'','',''), 'num');

    $topicref = "<a href=\"".$this->parser->makeUrl('wforum/topic', 'topic='.$this->id, false,true)."\">".$this->getFieldNewVal('name')."</a>";

    if($a[0] and trim($a[4]) and ($usr !== $a[2]))
    {
        // Notify creator
        $pars = array('to' => $a[4],
                      'subject' => strip_tags($this->parser->gt('subjnewtopic', '', $a[6])),
                      'message' => $this->parser->gt('messnewtopic', '', $topicref, $a[6])
                              );
        $this->parser->utils->sendMail($pars);
        $justsent = $a[2];
    }
    if($a[1] and trim($a[5]) and ($justsent !== $a[3]) and ($usr !== $a[3]))
    {
        // Notify creator
        $pars = array('to' => $a[5],
                      'subject' => strip_tags($this->parser->gt('subjnewtopic', '', $a[6])),
                      'message' => $this->parser->gt('messnewtopic', '', $topicref, $a[6])
                              );
        $this->parser->utils->sendMail($pars);
    }

    return '';
}

protected function _onDelete()
{
    $this->calc();
    return '';
}

protected function calc($upd = true)
{
    global $parser;
    $qty = $parser->utils->getFieldFromSql('SELECT COUNT(*) FROM wforum_topics WHERE forumid='.$this->getFieldVal('forumid'), 0);
    if($upd) $parser->conn->Execute('UPDATE wforum_forums SET topics='.$qty.' WHERE id='.$this->getFieldVal('forumid'));
    return $qty;
}

function getTopics($pars = array())
{
    $res = array();
    $pagelen = (isset($pars['pagelen'])) ? $pars['pagelen']  : 20;
    $page = (isset($pars['page'])) ? $pars['page']  : 0;
    $forum = (isset($pars['forum'])) ? $pars['forum']  : 0;
    $showpaginator = (isset($pars['showpaginator'])) ? $pars['showpaginator']  : true;
    if(!$forum) return $res;

    $q = $this->parser->utils->sql();

    $q->select('o.id');
    $q->select('o.name AS topicname');
    $q->lselect('u.name AS uname');
    $q->select('o.creaton');
    $q->select('o.creatby');
    $q->select('o.posts');
    $q->select('o.views');
    $q->select('o.lastpostid');
    $q->select('o.lastposttime');
    $q->select('o.lastposter');
    $q->select('o.sticky');
    $q->select('o.forumid');
    $q->from('wforum_topics o');
    $q->from('sys_objects u');
    $q->where('o.id>0');
    $q->where('o.creatby=u.objid');
    if($forum) $q->where("o.forumid=".$forum);
    $q->orderby('o.sticky DESC');
    $q->orderby('o.lastposttime DESC');
    $q->orderby('o.creaton DESC');
    if(!$this->parser->getUserId())
    {
        $q->from('wforum_forums f');
        $q->where('o.forumid=f.id');
        $q->where('f.isprivate=0');
    }

    $sql = $q->getSql();
    $totalpages = 0;
    $this->paginator_info = array('page' => 0,
                  'numrows' => 0,
                  'pagelen' => $pagelen,
                  'totalpages' => 0
    );
    if($showpaginator)
    {
        $pg = $q->parseSql($sql, true);
        $totalpages = ceil ($pg['rows'] / $pagelen);
        $numrows = $pg['rows'];
        if($page >= $totalpages) $page = $totalpages - 1;
        if($page < 0) $page = 0;
        $this->paginator_info = array('page' => $page,
                      'numrows' => $numrows,
                      'pagelen' => $pagelen,
                      'totalpages' => $totalpages
        );
    }

    $rs = $this->parser->conn->SelectLimit($sql, $pagelen, $page * $pagelen);
    if($rs->NumRows() <= 0) return $res;
    while($row = $rs->FetchRow())
    {
        $res[] = array('id' => $row[0],
                       'name' => $row[1],
                       'creatby' => $row[2],
                       'creaton' => $this->parser->utils->isoToDateformat($row[3], true),
                       'posts' => $row[5],
                       'views' => $row[6],
                       'lastpostid' => $row[7],
                       'lastposttime' => $this->parser->utils->isoToDateformat($row[8], true),
                       'lastposter' => $row[9],
                       'sticky' => $row[10],
                       'forumid' => $row[11],
                       'href' => $this->parser->makeUrl($this->topicpage, 'topic='.$row[0]),
                       'lasthref' => $this->parser->makeUrl($this->topicpage, 'topic='.$row[0].'&gotopost='.$row[7].'#post'.$row[7])

        );
    }
    return $res;

}

}

?>